package cz.cvut.fel.tar.archivator.transfer;

import cz.cvut.fel.tar.archivator.*;
import cz.cvut.fel.tar.archivator.customcontrols.*;
import cz.cvut.fel.tar.archivator.format.processor.*;
import cz.cvut.fel.tar.archivator.processors.*;

import javax.microedition.lcdui.*;

/**
 * Default processor implementation for transfers.
 * @author Adam Netocny
 */
public abstract class TransferProcessor
        extends Processor
        implements Transferable
{

    /**
     * Source.
     */
    protected Buffer in;

    /**
     * Default state.
     */
    protected int state = Transferable.TRANSFER_AVAILABLE;

    /**
     *
     */
    protected String aditionalInfo = "";

    /**
     * Constructor.
     */
    public TransferProcessor()
    {
        TransfersRegister.registerTransfer(this);
    }

    /**
     * Default post-process action.
     */
    public void runPostProcess()
    {
        synchronized (TarArchivatorMidlet.lockMe)
        {
            TarArchivatorMidlet.me.showFileBrowser();
        }
        new Thread()
        {

            public void run()
            {
                synchronized (TarArchivatorMidlet.lockMe)
                {
                    TarArchivatorMidlet.me.switchDisplayable(new AlertScreen(
                            "Success!\n" + aditionalInfo, AlertType.INFO));
                }
            }
        }.start();
    }

    /**
     * Sets Buffer as source stream.
     * @param in Buffer to be set.
     */
    public void setBuffer(Buffer in)
    {
        this.in = in;
        state = Transferable.TRANSFER_READY;
    }

    /**
     * Gets current state of this transfer.
     * @return Current state.
     */
    public int getState()
    {
        return state;
    }
}
