package cz.cvut.fel.tar.archivator.transfer;

import cz.cvut.fel.tar.archivator.format.processor.*;
import cz.cvut.fel.tar.archivator.processors.*;

import javax.microedition.lcdui.*;

/**
 * Default interface for all transfers.
 * @author Adam Netocny
 */
public interface Transferable
        extends ProgressRunnable
{

    /**
     * State: READY to be transfered.
     */
    public static final int TRANSFER_READY = 0;

    /**
     * State: AVAILABLE to use for transfer.
     */
    public static final int TRANSFER_AVAILABLE = 1;

    /**
     * State: NOT_AVAILABLE to use for transfer.
     */
    public static final int TRANSFER_NOT_AVAILABLE = 2;

    /**
     * Gets the transfer name.
     * @return Transfer name.
     */
    public String getName();

    /**
     * Gets the transfer icon.
     * @return Transfer icon.
     */
    public Image getIcon();

    /**
     * Sets Buffer as source stream.
     * @param in Buffer to be set.
     */
    public void setBuffer(Buffer in);

    /**
     * Gets current state of this transfer.
     * @return Current state.
     */
    public int getState();
}
